// TODO: implement navigation buffer after implementing internal routing

import { ArrowBack, ArrowForward, HomeOutlined } from "@mui/icons-material";
import { Box, IconButton, Stack } from "@mui/material";
import { useAtom } from "jotai";
import { routeAtom } from "../../lib/jotai";

export const NavigationButtons = () => {
  // atoms
  const [route, setRoute] = useAtom(routeAtom);

  const goHome = () => {
    setRoute("home");
  };

  return (
    <Box
      sx={{
        alignItems: "center",
        display: "flex",
        flexDirection: "row",
      }}
    >
      <IconButton
        onClick={goHome}
        size="small"
      >
        <HomeOutlined fontSize="inherit" />
      </IconButton>
    </Box>
  );
};
